当前位置:研发设计首页 >> 管理信息化 >> 数据管理 >> 在CATIA中运用宏处理大量数据
在CATIA中运用宏处理大量数据
2004-03-15 16:32:00  作者:  来源:cad世界
  • 在CATIA中运用宏处理大量数据

一、引言
随着机械设计的不断发展,三维辅助设计软件在产品设计和加工中成为不可缺少的重要工具。由于CATIA具有超强的自由曲面功能、逆向工程的功能及全面的组合分析功能,因此在世界范围内的航空航天及汽车工业中得到了广泛的应用。在飞机设计过程中,飞机的外形建模过程往往是先从外部读入外形数据,然后在CATIA中对这些数据进行处理。飞机外形数据通常是由许多点坐标组成,外形越精确,要求的数据就越多。在CATIA中,输入点的方法通常是在Shape的Generative Shape Design界面下的Point命令栏中手工将数据输入。飞机外形有成千上万个数据点,手动输入不仅费时,并且容易出错。本篇文章介绍了采用宏命令来自动读入数据的方法,并对这些数据自动进行相关的绘图处理。
二、宏的定义
宏是一系列组合在一起的命令和指令,以实现多任务执行的自动化。
宏可以用下列几种脚本语言编写,这取决于操作系统:
☆ Basicscript 2.2 sdk,用于Unix ;
☆ Vbscript,Visual Basic的脚本语言,用于Windows NT系统 ;
☆ Jscript,Javascript的一种应用,用于Windows NT系统。
三、创建宏和运行宏
1. 创建宏
宏可用于各种软件,其在各软件中的创建和运行基本相似,这里着重介绍宏在CATIA中的创建和运行过程。
创建过程是:首先打开CATIA,新建一个文件,然后进入菜单Tools,打开子菜单Macro下的Macros (或用Alt+F8命令),此时打开一个窗口,如图1所示。

图1 宏命令打开窗口
在Macro Name下的输入框中命名一个宏的名字,如Macro1。然后按Creat按钮,此时打开Macro Editor 窗口。在此窗口的文本框内输入宏的代码,保存后,该宏就创建完成了,如图2所示。

图2 创建宏
2.运行宏
首先选择宏,因为宏可保存于内部文件,也可保存于外部文件,所以首先在宏窗口的左下角的下拉框中选择是内部文件还是外部文件。如果是内部文件,则在宏窗口的文本框中会显示已创建的一系列宏,选择需要的宏,按下Run按钮,宏结果就可显示于窗口内。如果是外部文件,则选择宏窗口左侧的Select按钮,选择宏所在的文件目录,按下Run按钮,同样,宏结果也显示于窗口内。
四、宏在CATIA中的应用
1.利用宏输入数据
宏在CATIA中的应用非常广泛,它与CATIA的内核及内部函数的调用集成得很好。例如,在一个部件上打一系列的孔,从装配件上提取材料清单等等。在实际工作中,飞机的外形数据存于Excel文件中,利用宏来读取Excel文件中的数据。如果数据以其他文件格式保存,如dat文件格式,可转换为Excel文件格式,或者直接更改代码,从其他文件中直接读取。代码如下:
Language="VBSCRIPT" '因为本操作系统是 windows2000,所以 此宏是用'vbscript编 写的
Sub CATMain()
Dim partDocument1 As Document '创建文件
Set partDocument1 = CATIA.ActiveDocument
Dim part1 As Part '创建部件
Set part1 = partDocument1.Part
dim excel as object ' 调用excel对象
set excel=getobject("d: \外形数据.xls") '飞机外形数据存于d: \外形数据.xls文'件下
'利用循环,读入excel中的数据。此数据为飞机外形上的一些点的坐标值,这些'值分别存于excel的表单1中的B、C、D中,把这些值分别赋给变量x,y,z
i=1
do while x<>””
x=excel.worksheets(1).cells.range("B" & trim(cstr(i))).value
y=excel.worksheets(1).cells.range("C" & trim(cstr(i))).value
z=excel.worksheets(1).cells.range("D" & trim(cstr(i))).value
·
·
·
'定义点坐标
Dim hybridShapePointCoord1 As HybridShapePointCoord
Set hybridShapePointCoord1 = hybridShapeFactory1.AddNewPointCoord(x,y,z)
·
·
·
'输入点
hybridBody1.AppendHybridShape hybridShapePointCoord1
part1.InWorkObject = hybridShapePointCoord1
i=i+1
loop
part1.Update
End sub
按照创建和运行宏的步骤,把以上代码输入到自定义的一个宏的代码区中,保存并运行。这样,“外形数据.xls”文件中的所有飞机外形数据都被读取出来。CATIA系统为这些点自动编号,设计人员可从当前界面左侧最下一项Open Body.1的树形扩展目录中看到所有的点。
图3就是用此宏输入的机翼上的点。保存此CATIA文件为jiyi.CATpart。

图3 宏输入数据
2.利用宏处理数据
为了得到飞机的外形,我们需要对已输入的点进行处理,即把这些点用Spline命令连成若干条样条曲线,再对这些样条曲线进行处理。在这项任务中,把点连成线是一项繁重的重复性工作,而用宏可以很快地自动完成。宏代码如下:
Language="VBSCRIPT"
Sub CATMain()
'宏初始化
Dim documents1 As Documents
Set documents1 = CATIA.Documents

Dim partDocument1 As Document
Set partDocument1 = documents1.Item("Part1.CATPart")
·
·
·
'根据飞机外形要求,设置两个嵌套循环,内部循环完成一条样条曲线的点与点 '的连接,外部循环完成多条样条曲线的连接。
dim j as integer
for j=1 to const1
'样条曲线的定义和设置
Dim hybridShapeSpline1 As HybridShapeSpline
Set hybridShapeSpline1 = hybridShapeFactory1.AddNewSpline()
hybridShapeSpline1.SetSplineType 0
hybridShapeSpline1.SetClosing 1
·
·
·
dim i as integer
for i=1 to const2
Dim hybridShapePointCoord1 As HybridShape
Set hybridShapePointCoord1= hybridShapes1.Item(i+const2*(j-1))
·
·
·
hybridShapeSpline1.AddControlPoint hybridShapeControlPoint1
next
hybridBody1.AppendHybridShape hybridShapeSpline1
part1.InWorkObject = hybridShapeSpline1
part1.Update
next
part1.Update
End Sub
同样,按照创建和运行宏的步骤,把以上代码输入到自定义的另一宏的代码区中,保存并运行,结果如图4所示。

图4 宏处理数据
五、结束语
以上介绍了CATIA的宏在航空设计中的一些应用,它也可用于CATIA与外界交互数据量比较大的其他领域,如汽车领域等。宏的使用可以加快产品研发周期,提高工作效率。随着CATIA功能的不断增强以及CATIA应用范围的不断扩大,宏作为一种必不可少的辅助功能,将不断拓展CATIA的功能。



版权所有:智造网 京ICP证100778号 京公网安备110102003025 虚假新闻举报电话:010-88379107